%global enable_tests 1

Name:           nodejs-sqlite3
Version:        2.1.5
Release:        5%{?dist}
Summary:        Asynchronous, non-blocking SQLite3 bindings for Node.js

License:        BSD
URL:            https://github.com/developmentseed/node-sqlite3
Source0:        http://registry.npmjs.org/sqlite3/-/sqlite3-%{version}.tgz
# Link against system libraries
Patch0:         nodejs-sqlite3-libraries.patch
# Fix path for binary object to match packaging guidelines
Patch1:         nodejs-sqlite3-paths.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/117
Patch2:         nodejs-sqlite3-async.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/125
Patch3:         nodejs-sqlite3-uv.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/121
Patch4:         nodejs-sqlite3-callbacks.patch
# Offered upstream - https://github.com/developmentseed/node-sqlite3/pull/122
Patch5:         nodejs-sqlite3-tests.patch

ExclusiveArch:  %{ix86} x86_64 %{arm}

BuildRequires:  nodejs-devel
BuildRequires:  node-gyp
BuildRequires:  sqlite-devel

%if 0%{?enable_tests}
BuildRequires:  npm(expresso)
BuildRequires:  npm(step)
%endif

%description
%summary


%prep
%setup -q -n package
%patch0 -p0 -b .libraries
%patch1 -p0
%patch2 -p1 -b .async
%patch3 -p1 -b .uv
%patch4 -p1 -b .callbacks
%patch5 -p1 -b .tests
rm -rf deps node_modules


%build
export CXXFLAGS="%{optflags}"
node-gyp rebuild


%if 0%{?enable_tests}
%check
ln -s %{nodejs_sitelib} .
ln -s Release/node_sqlite3.node build/node_sqlite3.node
%{__nodejs} test/support/createdb.js
mkdir test/tmp
NODE_PATH=lib %{nodejs_sitelib}/expresso/bin/expresso test/*.test.js
%endif


%install
mkdir -p %{buildroot}/%{nodejs_sitearch}/sqlite3
cp -pr package.json lib %{buildroot}/%{nodejs_sitearch}/sqlite3
mkdir -p %{buildroot}/%{nodejs_sitearch}/sqlite3/build
install -p -D -m0755 build/Release/node_sqlite3.node %{buildroot}%{nodejs_sitearch}/sqlite3/build
%nodejs_symlink_deps


%files
%doc LICENSE README.md examples
%{nodejs_sitearch}/sqlite3


%changelog
* Wed Mar 13 2013 Tom Hughes <tom@compton.nu> - 2.1.5-5
- Restrict supported architectures using ExclusiveArch
- Rebuild against node 0.10

* Tue Mar  5 2013 Tom Hughes <tom@compton.nu> - 2.1.5-4
- Enable tests

* Mon Mar  4 2013 Tom Hughes <tom@compton.nu> - 2.1.5-3
- Fix gcc 4.8 compilation issues

* Sat Mar  2 2013 Tom Hughes <tom@compton.nu> - 2.1.5-2
- Fix permissions on node_sqite3.node
- Improve description

* Sun Feb 10 2013 Tom Hughes <tom@compton.nu> - 2.1.5-1
- Initial build of 2.1.5
